"{ Package: 'jv:calipel/s/benchmarks/stx' }"

Benchmark subclass:#BenchmarkSTX3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!


!BenchmarkSTX3 class methodsFor:'block speed'!

blockSpeed
    |a|

    a := 1.

    Transcript showCR:'[1 noop]'.
    Transcript show:( [1 noop] speed    ) printString.
    Transcript cr.

    Transcript showCR:'[''hello'' , '' world'']'.
    Transcript show:( ['hello' , ' world'] speed    ) printString.
    Transcript cr.

    Transcript showCR:'[1+1+1+1+1+1+1+1+1+1+1]'.
    Transcript show:( [1+1+1+1+1+1+1+1+1+1+1] speed ) printString.
    Transcript cr.

    Transcript showCR:'[1+1]'.
    Transcript show:( [1+1] speed                   ) printString.
    Transcript cr.

    Transcript showCR:'[]'.
    Transcript show:( [] speed                      ) printString.
    Transcript cr.

    Transcript showCR:'[a+a+a+a+a+a+a+a+a+a+a]'.
    Transcript show:( [a+a+a+a+a+a+a+a+a+a+a] speed ) printString.
    Transcript cr.

    Transcript showCR:'[a+a]'.
    Transcript show:( [a+a] speed                   ) printString.
    Transcript cr.

    "STXBenchmarks3 blockSpeed"
! !

!BenchmarkSTX3 class methodsFor:'collection benchmarks'!

collectionBenchmarks
    ObjectMemory garbageCollect.
    self ordCollBenchmark.
    ObjectMemory garbageCollect.
    self setBenchmark.
    ObjectMemory garbageCollect.
    self dictionaryBenchmark.
    ObjectMemory garbageCollect.

    "STXBenchmarks3 collectionBenchmarks"
!

collectionBenchmarks2
    ObjectMemory garbageCollect.
    self ordCollBenchmark2.
    ObjectMemory garbageCollect.
    self setBenchmark2.
    ObjectMemory garbageCollect.
    self dictionaryBenchmark2.
    ObjectMemory garbageCollect.

    "STXBenchmarks3 collectionBenchmarks2"
    "STXBenchmarks3 setBenchmark2"
    "STXBenchmarks3 dictionaryBenchmark2"
    "STXBenchmarks3 orderedCollectionBenchmark2"
!

dictionaryBenchmark
    Transcript showCR:'Dictionary:'.
    Transcript showCR:'   100 ' , (self dictionaryBenchmark:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self dictionaryBenchmark:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self dictionaryBenchmark:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self dictionaryBenchmark:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self dictionaryBenchmark:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self dictionaryBenchmark:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self dictionaryBenchmark:100000) printString.
    Transcript endEntry.

    "STXBenchmarks3 dictionaryBenchmark"
!

dictionaryBenchmark2
    Transcript showCR:'preallocated Dictionary:'.
    Transcript showCR:'   100 ' , (self dictionaryBenchmark2:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self dictionaryBenchmark2:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self dictionaryBenchmark2:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self dictionaryBenchmark2:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self dictionaryBenchmark2:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self dictionaryBenchmark2:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self dictionaryBenchmark2:100000) printString.
    Transcript endEntry.

    "STXBenchmarks3 dictionaryBenchmark2"
!

dictionaryBenchmark2:n
    |d|

    d := Dictionary new:n.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            d at:i put:i
        ]
    ]
!

dictionaryBenchmark:n
    |d|

    d := Dictionary new.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            d at:i put:i
        ]
    ]
!

ordCollBenchmark
    Transcript showCR:'OrderedCollection:'.
    Transcript showCR:'   100 ' , (self ordCollBenchmark:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self ordCollBenchmark:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self ordCollBenchmark:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self ordCollBenchmark:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self ordCollBenchmark:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self ordCollBenchmark:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self ordCollBenchmark:100000) printString
!

ordCollBenchmark2

    Transcript showCR:'preallocated OrderedCollection:'.
    Transcript showCR:'   100 ' , (self ordCollBenchmark2:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self ordCollBenchmark2:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self ordCollBenchmark2:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self ordCollBenchmark2:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self ordCollBenchmark2:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self ordCollBenchmark2:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self ordCollBenchmark2:100000) printString
!

ordCollBenchmark2:n
    |s|

    s := OrderedCollection new:n.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            s add:i
        ]
    ]
!

ordCollBenchmark:n
    |s|

    s := OrderedCollection new.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            s add:i
        ]
    ]
!

setBenchmark
    Transcript showCR:'Set:'.
    Transcript showCR:'   100 ' , (self setBenchmark:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self setBenchmark:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self setBenchmark:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self setBenchmark:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self setBenchmark:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self setBenchmark:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self setBenchmark:100000) printString
!

setBenchmark2
    Transcript showCR:'Preallocated Set:'.
    Transcript showCR:'   100 ' , (self setBenchmark2:100) printString.
    Transcript endEntry.
    Transcript showCR:'   500 ' , (self setBenchmark2:500) printString.
    Transcript endEntry.
    Transcript showCR:'  1000 ' , (self setBenchmark2:1000) printString.
    Transcript endEntry.
    Transcript showCR:'  5000 ' , (self setBenchmark2:5000) printString.
    Transcript endEntry.
    Transcript showCR:' 10000 ' , (self setBenchmark2:10000) printString.
    Transcript endEntry.
    Transcript showCR:' 50000 ' , (self setBenchmark2:50000) printString.
    Transcript endEntry.
    Transcript showCR:'100000 ' , (self setBenchmark2:100000) printString
!

setBenchmark2:n
    |s|

    s := Set new:n.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            s add:i
        ]
    ]
!

setBenchmark:n
    |s|

    s := Set new.
    ^ Time millisecondsToRun:[
        1 to:n do:[:i |
            s add:i
        ]
    ]
! !

!BenchmarkSTX3 class methodsFor:'helpers'!

noop
    ^ self
!

noopWith:a1
    ^ self
!

noopWith:a1 with:a2
    ^ self
!

noopWith:a1 with:a2 with:a3 with:a4 with:a5
    with:a6 with:a7 with:a8 with:a9 with:a10
    ^ self
! !

!BenchmarkSTX3 class methodsFor:'misc benchmarks'!

cachedSend
    |o t1 t2|

    "loop-time"
    t1 := Time millisecondsToRun:[
        1 to:1000000 do:[:i |
            i even ifTrue:[
                o := 1.2. "a float "
            ] ifFalse:[
                o := 1.3  "another float "
            ]
        ]
    ].
    t2 := Time millisecondsToRun:[
        1 to:1000000 do:[:i |
            i even ifTrue:[
                o := 1.2. "a float "
            ] ifFalse:[
                o := 1.3  "another float "
            ].
            o initialize.  "a cached polymorphic send"
        ]
    ].
    ^ t2 - t1

    "STXBenchmarks3 cachedSend"
!

countDown
    |t index|

    t := Time millisecondsToRun:[
        index := 100000.
        [index > 0] whileTrue:[
            index := index - 1
        ].
    ].
    ^ t

    "STXBenchmarks3 countDown"
!

fib
    |t|

    t := Time millisecondsToRun:[
        30 fib
    ].
    ^ t

    "STXBenchmarks3 fib"
!

polySend
    |o t1 t2|

    "loop time"
    t1 := Time millisecondsToRun:[
        1 to:1000000 do:[:i |
            i even ifTrue:[
                o := 1.2. "a float "
            ] ifFalse:[
                o := 1    "an integer "
            ]
        ]
    ].
    t2 := Time millisecondsToRun:[
        1 to:1000000 do:[:i |
            i even ifTrue:[
                o := 1.2. "a float "
            ] ifFalse:[
                o := 1    "an integer "
            ].
            o initialize.  "a polymorphic send"
        ]
    ].
    ^ t2 - t1

    "STXBenchmarks3 polySend"
!

send0
    |t|

    t := Time millisecondsToRun:[
        1000000 timesRepeat:[
            self noop
        ]
    ].
    ^ t

    "STXBenchmarks3 send0"
!

send1
    |t|

    t := Time millisecondsToRun:[
        1000000 timesRepeat:[
            self noopWith:1
        ]
    ].
    ^ t

    "STXBenchmarks3 send1"
!

send10
    |t|

    t := Time millisecondsToRun:[
        1000000 timesRepeat:[
            self noopWith:1 with:2 with:3 with:4 with:5
                     with:6 with:7 with:8 with:9 with:10
        ]
    ].
    ^ t

    "STXBenchmarks3 send10"
!

send2
    |t|

    t := Time millisecondsToRun:[
        1000000 timesRepeat:[
            self noopWith:1 with:2
        ]
    ].
    ^ t

    "STXBenchmarks3 send2"
! !

!BenchmarkSTX3 class methodsFor:'running'!

run
    Transcript showCR:'running benchmarks ...'.
    Transcript cr.
    Transcript endEntry.

    self run1.
    self run2.

    "STXBenchmarks3 run"
!

run1
    self blockSpeed.

    Transcript cr.
!

run2
    Transcript showCR:('countDown      ', self countDown printString).
    Transcript endEntry.
    Transcript showCR:('fib            ', self fib printString).
    Transcript endEntry.
    Transcript cr.

    Transcript showCR:('send 0-args    ', self send0 printString).
    Transcript endEntry.
    Transcript showCR:('send 1-args    ', self send1 printString).
    Transcript endEntry.
    Transcript showCR:('send 2-args    ', self send2 printString).
    Transcript endEntry.
    Transcript showCR:('send 10-args   ', self send10 printString).
    Transcript endEntry.
    Transcript showCR:('cached send    ', self cachedSend printString).
    Transcript endEntry.
    Transcript showCR:('polymorph send ', self polySend printString).
    Transcript endEntry.
    Transcript cr.

    Transcript showCR:('atAllPut       ', self atAllPut printString).
    Transcript endEntry.
    Transcript showCR:('atAllPut2      ', self atAllPut2 printString).
    Transcript endEntry.
    Transcript showCR:('sumTo          ', self sumTo printString).
    Transcript endEntry.
    Transcript showCR:('fastSumTo      ', self fastSumTo printString).
    Transcript endEntry.
    Transcript showCR:('nestedLoop     ', self nestedLoop printString).
    Transcript endEntry.
    Transcript showCR:('sumAll         ', self sumAll printString).
    Transcript endEntry.
    Transcript showCR:('sumAll2        ', self sumAll2 printString).
    Transcript endEntry.
    Transcript cr.

    "STXBenchmarks3 run2"
! !

!BenchmarkSTX3 class methodsFor:'self benchmarks'!

atAllPut
    |vec t|

    vec := Array new:100000.
    t := Time millisecondsToRun:[
        1 to:100000 do:[:i |
            vec at:i put:7
        ]
    ].
    ^ t

    "STXBenchmarks3 atAllPut"
!

atAllPut2
    |array t|

    array := Array new:100000.
    t := Time millisecondsToRun:[
        1 to:100000 do:[:i |
            array at:i put:7
        ]
    ].
    ^ t

    "STXBenchmarks3 atAllPut2"
!

fastSumTo
    |val i t|

    t := Time millisecondsToRun:[
        100 timesRepeat:[
            val := 0.
            i := 1.
            [i <= 10000] whileTrue:[
                val := val + i.
                i := i + 1
            ].
        ]
    ].

    ^ t

    "STXBenchmarks3 fastSumTo"
!

nestedLoop
    |i t|

    t := Time millisecondsToRun:[
        100 timesRepeat:[
            i := 0.
            1 to:100 do:[:l1 |
                1 to:100 do:[:l2 |
                    i := i + 1
                ]
            ]
        ]
    ].
    ^ t

    "STXBenchmarks3 nestedLoop"
!

sumAll 
    |vec t s|

    vec := Array new:100000.
    1 to:100000 do:[:i |
        vec at:i put:7
    ].
    s := 0.
    t := Time millisecondsToRun:[
        1 to:100000 do:[:i |
            s := s + (vec at:i)
        ]
    ].
    ^ t

    "STXBenchmarks3 sumAll"
!

sumAll2 
    |array t s|

    array := Array new:100000.
    1 to:100000 do:[:i |
        array at:i put:7
    ].
    s := 0.
    t := Time millisecondsToRun:[
        1 to:100000 do:[:i |
            s := s + (array at:i)
        ]
    ].
    ^ t

    "STXBenchmarks3 sumAll2"
!

sumTo
    |val t|

    t := Time millisecondsToRun:[
        100 timesRepeat:[
            val := 0.
            1 to:10000 do:[:i |
                val := val + i
            ]
        ]
    ].

    ^ t
    "STXBenchmarks3 sumTo"
! !

!BenchmarkSTX3 class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

