class CompareQuery
  include ActiveModel::Model

  attr_accessor :benchmark_infos

  def initialize(*args)
    super

    @benchmark_infos ||= {}
  end

  def filtered_benchmark_infos
    BenchmarkInfo.where(id: benchmark_infos_to_array_of_ids)
  end

  private

  def benchmark_infos_to_array_of_ids
    benchmark_infos.keys
  end
end
